import os,sys
abs_path = os.path.abspath(sys.argv[0])
basename = os.path.basename(sys.argv[0])
dirname = abs_path.replace(basename, "")
if not "%s/diskmon/lib" % dirname in sys.path:
   sys.path.insert(0,"%s/diskmon/lib" % dirname) # always with regard to parent script
if not "/usr/bp/lib/monitoring" in sys.path:
   sys.path.append("/usr/bp/lib/monitoring")

from bpdb       import *
from trap       import *

psql_command ="/usr/bin/psql bpdb postgres -c "
psql_command_tq ="/usr/bin/psql bpdb postgres -tq -c "

def toHex(dec):
   x = (dec % 16)
   digits = "0123456789ABCDEF"
   rest = dec / 16
   if (rest == 0):
      return digits[x]
   return toHex(rest) + digits[x]



def bin(x):  # python 2.7 has built-in function but 2.4 doesn't....
   """
   bin(number) -> string
   
   Stringifies an int or long in base 2.
   """
   if x < 0:
      return '-' + bin(-x)
   out = []
   if x == 0:
      out.append('0')
   while x > 0:
      out.append('01'[x & 1])
      x >>= 1
      pass
   try:
      return '0b' + ''.join(reversed(out))
   except NameError, ne2:
      out.reverse()
   return '0b' + ''.join(out)


def binary_bit_lifter(value, starting_bit): # 0b11 --> 0b11000000 when starting bit=7
   bin_bits = bin(value)
   adjusted_value=0
   for i in range(len(bin_bits)): # 0b like 0x
      if i<2: continue
      each_char=bin_bits[i]
      adjusted_value+=int(each_char)* 2**(starting_bit-(i-2))
   return adjusted_value


def get_hex(value,n_digit):
    hex_value=hex(value)[2:]
    for i in range(n_digit-len(hex_value)):
        hex_value="0"+hex_value
    return hex_value

def does_exist(command):
    command += " | wc -l"
    theWord = get_first_word(command)
    if int(theWord) > 0:
        return True
    else:
        return False

def CloseAlert(trapTarget, trapMessage="Closing"):
   PostAlert(0, 140, trapTarget, trapMessage)
   return

#<code>          (0) close it (1) either open new one, reopen the closed one, or update it
def PostAlert(code, notification_id, trapTarget, trapMessage="Closing"):
   #PostAlert(0, 140, alert.target, alert.alert_text)  in case of 140 alert_text is not important

   if CONFIG.testOn:
      print "testOn:: input ", trapMessage
   
   command = "/usr/bp/bin/populate_alerts_for_python.php -c %d" % code + " -n %d" % notification_id + " -t '%s'" % trapTarget + " -s '%s'" % trapMessage

   if notification_id ==137 and "SMART" in trapMessage: 
      import datetime
      now = datetime.datetime.now()
      if CONFIG.testOn == "02":
         now = now - datetime.timedelta(hours = 12)

      theDay = now.strftime("%a")
      if theDay == "Sat" or theDay == "Sun" or not (now.hour >= 6 and now.hour <15): # during the business hour 0600 - 1459
         return

   if CONFIG.selfhealing:
      if not CONFIG.confirm:
         print command + " %d" % len(trapMessage)
      else:   
         os.system(command)

   if CONFIG.testOn:
      print "testOn:: fired ", trapMessage

   return   

def HandleAlert(shortName, notification_id, trapTarget, trapMessage, option=""):
   if not CONFIG.selfhealing: return

   if "util" in  CONFIG.verbose:
      print "util.py in HandleAlert  ", shortName, notification_id, trapTarget, trapMessage, CONFIG.delayedAlert

   if CONFIG.delayedAlert:
      DelayedAlert(shortName, notification_id, trapTarget, trapMessage, option)
   else:   
      OpenAlert(shortName, notification_id, trapTarget, trapMessage)



##### This is standard way
def OpenAlert(shortName, notification_id, trapTarget, trapMessage): #shortName is VD name #assumption... we have only one alert active for each array
   command = psql_command + "\"SELECT * FROM bp.alerts WHERE closed=FALSE and (notification_id = 137 or notification_id = 138)\" | grep 13 | grep %s" % shortName
   activeAlerts = GetAlerts(command)
   #close the one from the same VD name because of assumption that there is only one state per raid...
   for alert in activeAlerts:
      #print alert.target, "-vs-",trapTarget 
      if alert.target != trapTarget or alert.notification_id != notification_id:  
         CloseAlert(alert.target, alert.alert_text) # closing
   PostAlert(1, notification_id, trapTarget, trapMessage) # if exists, it will update timestamp of updated

#### This is for standard as well as delayed...
def CloseAnyActiveAlerts(shortName, notification_id=-1):
   if not CONFIG.selfhealing: return
   
   command =psql_command
   if notification_id<0:
      command +="\"SELECT * FROM bp.alerts WHERE closed=FALSE and (notification_id = 137 or notification_id = 138)\" | grep 13 | egrep '%s'" % shortName
   else:
      command +="\"SELECT * FROM bp.alerts WHERE closed=FALSE and (notification_id = %d)\" | grep %d | egrep '%s'" % (notification_id, notification_id, shortName)
      
   activeAlerts = GetAlerts(command)

   if len(activeAlerts):   
      for alert in activeAlerts: #closing any open one
         CloseAlert(alert.target)
         category_id = -1
         if notification_id>=137 and notification_id<=140:
            category_id = 15
         elif notification_id>=155 and notification_id<=158:
            category_id = 16

         # SUPPORT doesn't want to get a trap for closing any more  
         trapToSend = Trap(category_id, alert.target, "The following alert has been closed ::: %s" % alert.alert_text, 3, 0)
         trapToSend.book_to_audit_history()

   else: # no active alert... could be due to dbDown
      category_id = 15
      command =psql_command_tq
      command+="\"SELECT id,oid,time_sent,destination,community,traptype,regexp_replace(object,E'[\\n\\r]+',' ','g'),severity,status,description "
      command+="FROM bp.snmp_history WHERE oid LIKE '%%.%d' order by id desc\" | grep %s" % (category_id, shortName)

      if not CONFIG.dbON and os.path.exists("/var/log/monitoring_disks/bp.snmp_history.dbout"):
         command = "/usr/bin/tac /var/log/monitoring_disks/bp.snmp_history.dbout | grep %s" % shortName 

      if "util" in  CONFIG.verbose:   print "CloseAnyActiveAlerts:: ", command

      snmpTraps = GetTraps(command)
      prevTrapId = -1
      for i in range(len(snmpTraps)):
         snmp = snmpTraps[i]
         if shortName in snmp.object and snmp.status==1: # check only open one... When there is no problematic disk, shortName would be OS or VD0 or c0
            prevTrapId = i
            if "util" in  CONFIG.verbose:
               print snmp
            break
         
      if "util" in  CONFIG.verbose:    print "CloseAnyActiveAlerts:: ", prevTrapId
         
      # SUPPORT doesn't want to get a trap for closing any more  
      if prevTrapId >=0:   
         if snmpTraps[prevTrapId].status == 1: # active
            CloseSNMPTrap(snmpTraps[prevTrapId])
            if "XFS" in shortName:
               trapToSend = Trap(category_id, shortName, "%s ++++ XFS filesystem looks okay" % shortName, 3, 0)
               trapToSend.book_to_audit_history()
            else:   
               trapToSend = Trap(category_id, shortName, "%s ++++ Disks and RAID are healthy" % shortName, 3, 0)
               trapToSend.book_to_audit_history()

def CloseSNMPTrap(snmp_history):
   command ="%s \"UPDATE bp.snmp_history SET status='0' WHERE id=%d\"" % (psql_command, snmp_history.id)

   if not CONFIG.dbON:
      command = "sed -e s/\"Disk health state has changed | %s | 1 | 1 |\"/\"Disk health state has changed "
      command+= "| %s | 1 | 0\"/g /var/log/monitoring_disks/bp.snmp_history.dbout > /var/log/monitoring_disks/bp.snmp_history.dbout" \
          % (snmp_history.object, snmp_history.object)
      
   run_command(command)
   return

def DelayedAlert(shortName, notification_id, trapTarget, trapMessage, option=""): #shortName is VD name
   category_id = -1

   #137 is for disk health trap with FATAL
   if notification_id>=137 and notification_id<=140:
      category_id = 15
   elif notification_id>=155 and notification_id<=158:
      category_id = 16

   severity = 1   
   #if notification_id in [137, 157]   : severity =1   
   if notification_id in [156]        : severity =2   
   if notification_id in [138,139,155]: severity =3   

   #=====
   command = psql_command_tq
   command+= "\"SELECT id,oid,time_sent,destination,community,traptype,regexp_replace(object,E'[\\n\\r]+',' ','g'),severity,status,description "
   command+= "FROM bp.snmp_history WHERE oid LIKE '%%.%d' order by id desc\" | grep %s" % (category_id, shortName)
   if not CONFIG.dbON and os.path.exists("/var/log/monitoring_disks/bp.snmp_history.dbout"):
      command = "/usr/bin/tac /var/log/monitoring_disks/bp.snmp_history.dbout | grep %s" % shortName 

   snmpTraps = GetTraps(command)
   prevTrapId = -1
   for i in range(len(snmpTraps)):
      snmp = snmpTraps[i]
      if snmp.object == trapTarget and snmp.status==1: # status=1 open
         prevTrapId = i
         break

   trapToSend = Trap(category_id, trapTarget, trapMessage, severity, 1)

   if "util" in  CONFIG.verbose:
      print "util.py:: DelayedAlert", trapToSend, len(snmpTraps), trapTarget
      if len(snmpTraps):
         print "util.py:: prevTrapId in array [%d] " %  prevTrapId, snmpTraps[prevTrapId]

   now = CONFIG.now
   now_day=now.strftime("%a")
   now_hr =now.hour

   if option=="NoTrapWeekend":  # We don't want to send proactive alert trap considering support organization ability
      if now_day in ["Fri","Sat","Sun"] or (now_day=="Thu" and now_hr>=15):
         if "util" in  CONFIG.verbose:
            print "util.py in DelayedAlert Not sending trap on %s and %d hr  "%( now_day, now_hr)
         return
   
   ##################   
   ### SENDING TRAP
   ######################
   
   if prevTrapId <0:
      trapToSend.send_trap()
      return
   else:
      if "util" in  CONFIG.verbose:
         print "util.py:: ", snmpTraps[prevTrapId].severity, trapToSend.severity, snmpTraps[prevTrapId].status, trapToSend.status 
         print "util.py:: ", snmpTraps[prevTrapId]
      if snmpTraps[prevTrapId].severity != trapToSend.severity or snmpTraps[prevTrapId].status != trapToSend.status:
         trapToSend.send_trap()
         return

   # if there is non-related alerts, close them... based on big assumption "ONLY ONE ALERT PER VD" one
   # shortName = VD name
   command = psql_command_tq
   command+= "\"SELECT * FROM bp.alerts WHERE closed=FALSE and notification_id = %d order by alert_id desc\" | grep %d | grep %s"\
       % (notification_id, notification_id, shortName) #shortName = VD name
   activeAlerts = GetAlerts(command)
   
   if "util" in  CONFIG.verbose:   print len(activeAlerts), "   ", command
      
   prevAlertId = -1
   for i in range(len(activeAlerts)):
      #print alert.target, "-vs-",trapTarget 
      alert = activeAlerts[i]
      if alert.target == trapTarget and alert.notification_id == notification_id:  
         if prevAlertId <0:
            prevAlertId = i
         else:   
            CloseAlert(alert.target, alert.alert_text) # closing

   if "util" in  CONFIG.verbose:
      print "util.py::alert handling... ", len(activeAlerts), prevAlertId, "   ", command
      
   if prevAlertId >=0:
      return
   else: #no open alert
      snmp = snmpTraps[prevTrapId]

      then  =snmp.time_sent
      dday  =snmp.time_sent_day
      dhour =snmp.time_sent_hour
      
      if "util" in  CONFIG.verbose:
         print "util.py:: snmp.severity", snmp.severity

      #Logic: assuming that support CSR can respond between 6AM to 3PM during the weekday:
      # 1. Mon - Thu: Alerts need to be delayed by 24   hours and 24   + 12 hours if it happens after 14:59
      # 2. Fri      :                           by 24*3 hours and 24*3 + 12 hours if it happens after 14:59
      # 3. Sat      :                           by 24*3 hours and 24*3 - 12 hours if it happens after 14:59
      # 4. Sun      :                           by 24*2 hours and 24*2 - 12 hours if it happens after 14:59

      offset = 24 #   if dday == "Mon" or dday == "Tue" or dday == "Wed" or dday == "Thu":
      if dday == "Fri" or dday == "Sat":
         offset += 24*2
         if dhour >=15:
            if dday == "Fri":
               offset +=12
            else:
               offset -=12 
      elif dday == "Sun":   
         offset += 24
         if dhour >= 15:
            offset -= 12
      else:   
         if dhour >= 15:
            offset += 12

      threshold = then + datetime.timedelta(hours=offset)

      if "util" in  CONFIG.verbose:
         print "util.py:: ", now, threshold

      if now > threshold:
         trapToSend.book_to_alerts()

      return   

########### Utility
# http://code.activestate.com/recipes/410692/
# This class provides the functionality we want. You only need to look at
# this if you want to know how this works. It only needs to be defined
# once, no need to muck around with its internals.
class switch(object):
   def __init__(self, value):
      self.value = value
      self.fall = False
      
   def __iter__(self):
      """Return the match method once, then stop"""
      yield self.match
      raise StopIteration

   def match(self, *args):
      """Indicate whether or not to enter a case suite"""
      if self.fall or not args:
         return True
      elif self.value in args: # changed for v1.5, see below
         self.fall = True
         return True
      else:
         return False


# there is hex() built-in function but it spit 0x
class bcolors:
   RED    = '\033[91m'
   GREEN  = '\033[92m'
   YELLOW = '\033[93m'
   BLUE   = '\033[94m'
   PURPLE = '\033[95m'
   CYAN   = '\033[96m'
   ENDC   = '\033[0m'
   def disable(self):
      self.RED = ''
      self.BLUE = ''
      self.GREEN = ''
      self.YELLOW = ''
      self.PURPLE = ''
      self.CYAN = ''
      self.ENDC = ''

def red(text):
    return bcolors.RED + text + bcolors.ENDC;
def blue(text):
    return bcolors.BLUE + text + bcolors.ENDC;
def green(text):
    return bcolors.GREEN + text + bcolors.ENDC;



def get_dir_name(path):
    abs_path = os.path.abspath(path)
    basename = os.path.basename(path)
    dirname = abs_path.replace(basename, "")
    return dirname

def printout(command):
   print get_printout(command,False)

def get_aggregated_lines(command):
   lines = get_printout(command)

   newlines = []
   newline = ""
   count =0
   for line in lines:
       if count > 0 and len(line) <8:
           newlines.append(newline)
           newline =""
       else:    
           newline = newline + " " + line
       count += 1

   return newlines   

def get_twolines(command):
   lines = get_printout(command)

   newlines = []
   newline = ""
   count =0
   for line in lines:
      newline = newline + " " + line
      if count%2==1:
         newlines.append(newline)
         newline =""
      count += 1

   return newlines   

def run_command(command, secondsToSleep=0, confirm=False, debug=False):
   message = "Executing # %s " % command
   if CONFIG.confirm or confirm:
      if CONFIG.debug or debug: print message
      os.system(command)
      if secondsToSleep>0:
         import time
         time.sleep(secondsToSleep)
   else:
      message = message + " (NOT EXECUTED)"
      print message
   
   return

def run_query(query, secondsToSleep=0, confirm=False):
    command = "/usr/bin/psql bpdb postgres -c \"%s\"" % query
    if CONFIG.dbON:
       run_command(command, secondsToSleep, confirm)
    return

def get_queryResult(command):

   if CONFIG.debug: print "# " + command
   import commands      

   command = "/usr/bin/psql bpdb postgres -tq -c \"%s\" | grep -v ^$" % command
   return commands.getoutput(command).splitlines()

def printArray(arrays):
   for arr in arrays:
      print arr



